/*
  - The Developer of this Code is HJ van Rantwijk. Copyright
  - (C) 2004-2007 by HJ van Rantwijk.  All Rights Reserved.
  -
  - Contributors:
  -	   Michael Vincent van Rantwijk <mv_van_rantwijk@yahoo.com>
  -
*/

const Cc = Components.classes;
const Ci = Components.interfaces;
const Cr = Components.results;

var mzAboutMultiZilla = {
  QueryInterface: function QueryInterface(aIID) {
    if (aIID.equals(Ci.nsISupports) || aIID.equals(Ci.nsIAboutModule) ||
        aIID.equals(Ci.nsIFactory))
      return this;

    throw Components.results.NS_ERROR_NO_INTERFACE;
  },

  newChannel: function(aURI) {
    var ioService = Cc["@mozilla.org/network/io-service;1"].getService(Ci.nsIIOService);
    var channel = ioService.newChannel("chrome://multiviews/content/about.xhtml", null, null);
    channel.originalURI = aURI;
    return channel;
  },

  getURIFlags: function getURIFlags(aURI) {
    return 0;
  },

  createInstance: function createInstance(aOuter, aIID) {
    if (aOuter != null)
      throw Components.results.NS_ERROR_NO_AGGREGATION;

    return this.QueryInterface(aIID);
  },

  lockFactory: function lockFactory(aLock) {
  }
};

var mzAboutModule = {
  mClassID: Components.ID("{2107995c-fd5e-11db-8314-0800200c9a66}"),
  mContractID: "@mozilla.org/network/protocol/about;1?what=multizilla",

  QueryInterface: function QueryInterface(aIID) {
    if (aIID.equals(Ci.nsIModule) || aIID.equals(Ci.nsISupports))
      return this;

    throw Cr.NS_ERROR_NO_INTERFACE;
  },

  getClassObject: function(aCompMgr, aCID, aIID) {
    if (aCID.equals(this.mClassID))
      return mzAboutMultiZilla.QueryInterface(aIID);

    throw Cr.NS_ERROR_FACTORY_NOT_REGISTERED;
  },

  registerSelf: function(aCompMgr, aFileSpec, aLocation, aType) {
    aCompMgr = aCompMgr.QueryInterface(Ci.nsIComponentRegistrar);
    aCompMgr.registerFactoryLocation(this.mClassID, "about:multizilla", 
                                     this.mContractID, aFileSpec, aLocation, 
                                     aType);
  },
    
  unregisterSelf: function(aCompMgr, aLocation, aType) {
    aCompMgr = aCompMgr.QueryInterface(Ci.nsIComponentRegistrar);
    aCompMgr.unregisterFactoryLocation(this.mClassID, aLocation);
  },

  canUnload: function canUnload(aCompMgr) {
    return true;
  }
};

function NSGetModule(compMgr, fileSpec) {
  return mzAboutModule;
}
